package uy.edu.fing.chesstrack.modulovision;



import java.util.ArrayList;
import java.util.List;

import org.opencv.core.Mat;

import uy.edu.fing.chesstrack.modulovision.imgproc.EcualizarImagen;
import uy.edu.fing.chesstrack.modulovision.imgproc.ImgProcInterface;
import android.util.Log;



public class Adquisicion   {
	List<ImgProcInterface> listProc;

	private static final String TAG = "CHESSTRACK::Adquisicion";


	public Adquisicion() {
		super();
		Log.i(TAG, "Cargado....");
		listProc = new ArrayList<ImgProcInterface>();
		listProc.add( new EcualizarImagen());
	}

	/**
	 * PRocesa el frame pasado por parametro
	 * @param inputPicture
	 * @return
	 * ver http://dsp.stackexchange.com/questions/2805/how-does-opencv-find-chessboard-corners
	 * http://www.cvg.ethz.ch/teaching/2012fall/cvl/Tutorial-OpenCV.pdf
	 */
	public synchronized Mat processFrame(Mat inputPicture) {
		Log.i(TAG, "processFrame inicia");
		Mat salida = inputPicture;
		//
		//		//		Core.line(salida, new Point(0, 5), new Point(salida.cols()/2,salida.rows()/2), new Scalar(0, 255, 0, 255), 3);
		//
		//		//		Core.circle(salida,  new Point(salida.cols()/2,salida.rows()/2), 120, new Scalar(0,0 , 255, 255));
		//
		//		MatOfPoint2f pointBuf;
		//		boolean found = Calib3d.findChessboardCorners( salida, salida.size(), pointBuf,
		//				Calib3d.CALIB_CB_ADAPTIVE_THRESH |Calib3d.CALIB_CB_FAST_CHECK | Calib3d.CALIB_CB_NORMALIZE_IMAGE);
		//		if (found){
		//			Mat viewGray;
		//			Imgproc.cvtColor(salida, viewGray, Imgproc.COLOR_BGR2GRAY);
		//			cornerSubPix( viewGray, pointBuf, new Size(11,11),
		//					new Size(-1,-1), TermCriteria( TermCriteria.TERMCRIT_EPS+TermCriteria.TERMCRIT_ITER, 30, 0.1 ));
		//
		//
		//
		//			MatOfPoint2f corners = new MatOfPoint2f();
		//			Imgproc.cornerSubPix(image, corners , winSize, zeroZone, criteria);
		//			Calib3d.drawChessboardCorners(salida, new Size(5, 5), corners, patternWasFound);
		//		}

		Mat prevImg = inputPicture;

		for (ImgProcInterface proc: listProc){
			prevImg = proc.procesarImagen(prevImg);
		}


		return prevImg;

	}
}
